package com.bean;

import javax.faces.event.ActionEvent;

import org.richfaces.model.TreeNodeImpl;

public class TreeNode {

	private String value;
	private String state;

	private TreeNode parent;
	private TreeNode[] children;

	public TreeNode(String value) {
		this.value = value;
		this.state = "";
	}

	public synchronized void addNode(TreeNode newChild) {
		System.out.println("addNode(" + newChild.getValue() + ")");
		if (this.children == null) {
			TreeNode[] merged = new TreeNode[1];
			merged[0] = newChild;
			this.children = merged;
		} else {
			TreeNode[] merged = new TreeNode[this.children.length + 1];
			int i;
			for (i = 0; i < this.children.length; i++) {
				merged[i] = this.children[i];
			}
			merged[merged.length - 1] = newChild;
			this.children = merged;
		}
	}

	public synchronized void addNodes(TreeNode[] newChildren) {
		System.out.println("addNodeS(" + newChildren.length + ")");
		TreeNode[] merged = new TreeNode[newChildren.length
				+ this.children.length];
		int i;
		for (i = 0; i <= this.children.length; i++) {
			merged[i] = this.children[i];
		}
		for (int i2 = i; i2 <= newChildren.length + i; i2++) {
			merged[i2] = newChildren[i2];
		}
		this.children = merged;
	}

	public synchronized void removeNodes(TreeNode[] removeChildren) {
		TreeNode[] splitted = new TreeNode[this.children.length
				- removeChildren.length];
		int pos = 0;
		for (int i = 0; i <= this.children.length; i++) {
			boolean contains = false;
			for (int j = 0; j <= removeChildren.length; j++) {
				if (this.children[i] == removeChildren[j]) {
					contains = true;
				}
			}
			if (contains == false) {
				splitted[pos] = this.children[i];
				pos++;
			}
		}
	}

	public String checkSibling() {
		// System.out.println("checkSibling() of "+this.value);
		if (this.children != null) {
			String state = null;
			int checked = 0;
			int sub = 0;
			int i;
			TreeNode[] siblings = this.children;
			for (i = 0; i < siblings.length; i++) {

				TreeNode treeNode = siblings[i];
				// System.out.println("\t"+treeNode.getValue()+" - "+treeNode.getState());
				if (!treeNode.getState().equals("")) {
					if (treeNode.getState().equals("checked")) {
						checked++;
					} else if (treeNode.getState().equals("sub")) {
						sub++;
					}
				}

			}

			if (checked == i) {
				state = "checked";
			} else if (sub > 0 || checked > 0) {
				state = "sub";
			} else {
				state = "";
			}
			// System.out.println("siblings: "+i+" (checked: "+checked+" sub: "+sub+") -> "+state);
			return state;
		} else {
			return "";
		}

	}

	public void setChildsChecked(TreeNode node) {
		// System.out.println("TreeNode -> setChildsChecked of "+node.getValue());
		if (node.getChildren() != null) {
			TreeNode[] children = node.getChildren();
			for (int i = 0; i < children.length; i++) {
				TreeNode treeNode = children[i];
				treeNode.setState("checked");
				setChildsChecked(treeNode);
			}
		}
	}

	public void setChildsUnchecked(TreeNode node) {
		// System.out.println("TreeNode -> setChildsUnchecked of "+node.getValue());
		if (node.getChildren() != null) {
			TreeNode[] children = node.getChildren();
			for (int i = 0; i < children.length; i++) {
				TreeNode treeNode = children[i];
				treeNode.setState("");
				setChildsUnchecked(treeNode);
			}
		}
	}

	public void setParentsState(TreeNode node) {
		System.out.println("TreeNode -> setParentsState of " + node.getValue());
		node.setState(node.checkSibling());
		if (node.getParent() != null) {
			setParentsState(node.getParent());
		}
	}

	public void actionListener(ActionEvent ae) {
		// System.out.println("TreeNode -> nodeListener fired by "+ae.getComponent().getId());
		if (this.state == "checked") {
			this.state = "";
			setChildsUnchecked(this);
		} else {
			this.state = "checked";
			setChildsChecked(this);
		}
		if (this.parent != null) {
			setParentsState(this.parent);
		}

	}

	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}

	public TreeNode[] getChildren() {
		return children;
	}

	public void setChildren(TreeNode[] children) {
		this.children = children;
	}

	public TreeNode getParent() {
		if (parent == null) {
			return null;
		} else {
			return parent;
		}
	}

	public void setParent(TreeNode parent) {
		this.parent = parent;
	}

	public String getState() {
		return state;
	}

	public void setState(String state) {
		this.state = state;
	}

}
